package trajectoire;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.applet.*;
import java.awt.event.*;


public class Trajectoire extends Applet {
    
    protected ImageCanvas ic;
    final static int imgdimx = 800;
    final static int imgdimy = 600;
    protected Image croquis;
    double a = 100;
    double b = 60;
    double xS = -150;
    double xSP = (xS - imgdimx/2) / 2;
    int branche = 0;
    
    Dessin dessin;
    JSlider sliderSP;
    
    public void init() {
        setLayout(new BorderLayout());
        final JPanel croquisPane = new JPanel(new BorderLayout());
        add(croquisPane, BorderLayout.CENTER);
        croquis = createImage(imgdimx, imgdimy);
        ic = new ImageCanvas(imgdimx, imgdimy);
        croquisPane.add(ic, BorderLayout.CENTER);
        dessin = new Dessin(croquis, imgdimx, imgdimy, a, b, xS);
        majCroquis();
        
        Panel hpan = new Panel(new FlowLayout());
        hpan.setBackground(Color.white);
        croquisPane.add(hpan, BorderLayout.NORTH);
        hpan.add(new JLabel("Position de S' :"));
        
        // liste des segments
        JPanel panSegments = new JPanel(new FlowLayout(FlowLayout.LEFT));
        panSegments.setBackground(Color.white);
        hpan.add(panSegments);
        final JComboBox segments = new JComboBox();
        panSegments.add(segments);
        segments.addItem("Choisissez un segment");
        segments.addItem("1re branche ct S");
        segments.addItem("1re branche ct S1");
        segments.addItem("2me branche ct S");
        segments.addItem("2me branche ct S1");
        segments.addItemListener(new ItemListener() {
            public void itemStateChanged(ItemEvent ie) {
                if (segments.getSelectedItem() != null) {
                    if (segments.getSelectedIndex() == 0) {
                        sliderSP.setEnabled(false);
                        sliderSP.setMinimum(-imgdimx/2);
                        sliderSP.setMaximum((int)xS - 1);
                        if (branche > 2)
                            sliderSP.setValue((sliderSP.getMinimum() + sliderSP.getMaximum()) / 2);
                        branche = 0;
                        majCroquis();
                    }
                    if (segments.getSelectedIndex() == 1) {
                        sliderSP.setEnabled(true);
                        sliderSP.setMinimum(-imgdimx/2);
                        sliderSP.setMaximum((int)xS - 1);
                        if (branche > 2)
                            sliderSP.setValue((sliderSP.getMinimum() + sliderSP.getMaximum()) / 2);
                        branche = 1;
                        majCroquis();
                    }
                    if (segments.getSelectedIndex() == 2) {
                        sliderSP.setEnabled(true);
                        sliderSP.setMinimum(-imgdimx/2);
                        sliderSP.setMaximum((int)xS - 1);
                        if (branche > 2)
                            sliderSP.setValue((sliderSP.getMinimum() + sliderSP.getMaximum()) / 2);
                        branche = 2;
                        majCroquis();
                    }
                    if (segments.getSelectedIndex() == 3) {
                        sliderSP.setEnabled(true);
                        sliderSP.setMinimum((int)a);
                        sliderSP.setMaximum(imgdimx/2);
                        if (branche != 3 && branche != 4)
                            sliderSP.setValue((sliderSP.getMinimum() + sliderSP.getMaximum()) / 2);
                        branche = 3;
                        majCroquis();
                    }
                    if (segments.getSelectedIndex() == 4) {
                        sliderSP.setEnabled(true);
                        sliderSP.setMinimum((int)a);
                        sliderSP.setMaximum(imgdimx/2);
                        if (branche != 3 && branche != 4)
                            sliderSP.setValue((sliderSP.getMinimum() + sliderSP.getMaximum()) / 2);
                        branche = 4;
                        majCroquis();
                    }
                }
            }
        });
        
        // ordonne du point S'
        JPanel panSlider = new JPanel(new FlowLayout(FlowLayout.LEFT));
        panSlider.setBackground(Color.white);
        hpan.add(panSlider);
        sliderSP = new JSlider(-imgdimx/2, (int)xS, (int)xSP);
        panSlider.add(sliderSP);
        sliderSP.setEnabled(false);
        sliderSP.setMinorTickSpacing(5);
        sliderSP.setMajorTickSpacing(5);
        //sliderSP.setPaintTicks(true);
        //sliderSP.setPaintLabels(true);
        //sliderSP.setLabelTable(sliderSP.createStandardLabels(200));
        sliderSP.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent ce) {
                JSlider monSlider = (JSlider) ce.getSource();
                xSP = monSlider.getValue();
                majCroquis();
            }
        });
    }
    
    
    protected void majCroquis() {
        dessin.dessiner(xSP, branche);
        ic.updateImage(croquis);
    }
    
}
